package com.zase.nosql.pojo;

import java.util.HashMap;
import java.util.Map;

import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBAttribute;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBAutoGeneratedKey;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBHashKey;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBTable;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBVersionAttribute;
import com.amazonaws.services.dynamodbv2.model.ScalarAttributeType;

/**
 *  7 Attributes 8 bytes per object + 8 bytes for the actual SourceClass.
 *  Total Size = 64bytes
 *  
 *  Recommended # of reads per second X 4KB on Consistent X2 for Eventual.
 *  Recommended # of writes per second 1KB.
 * @author mramos
 *
 */
@DynamoDBTable(tableName=Source.TABLE_NAME)
public class Source {
	
	public static final String TABLE_NAME="Source";
	private static final Map<String, ScalarAttributeType> TABLE_ATTRS = new HashMap<String, ScalarAttributeType>();
	public static String[] COLUMN_FAMILY;
	public static final KeyDataTypePair KEY_PK = new KeyDataTypePair( "id", ScalarAttributeType.S );
	public static final KeyDataTypePair RANGE_PK = new KeyDataTypePair( "serialNumber", ScalarAttributeType.S );
	public static final KeyDataTypePair RANGE_PK_1 = new KeyDataTypePair( "location", ScalarAttributeType.S );
	public static final String KEY_ATTR="id";
	public static final String VERSION_ATTR="version";
	
	static {
		TABLE_ATTRS.put("ip_address", ScalarAttributeType.S); 
		TABLE_ATTRS.put("location", ScalarAttributeType.S);
		TABLE_ATTRS.put("name", ScalarAttributeType.S);
		TABLE_ATTRS.put("serialNumber", ScalarAttributeType.S);
		TABLE_ATTRS.put("uuid", ScalarAttributeType.S);
		TABLE_ATTRS.put("version", ScalarAttributeType.N);
		COLUMN_FAMILY = TABLE_ATTRS.keySet().toArray(new String[ TABLE_ATTRS.size() ]);
	}
	
	public static final ScalarAttributeType getTableAttributeType(String data){
		return TABLE_ATTRS.get(data);
	}
	
	public static class KeyDataTypePair{
		String columnName;
		ScalarAttributeType scalarType;
		
		public KeyDataTypePair(String c, ScalarAttributeType s){
			this.columnName = c;
			this.scalarType = s;
		}
		
		public String getColumnName(){
			return columnName;
		}
		
		public ScalarAttributeType getScalarType(){
			return scalarType;
		}
	}
	
		
	private String id;
	private String ip_address;
	private String location;
	private String name;
	private String serialNumber;
	private String uuid;
	private Integer version;
	
	@DynamoDBVersionAttribute
	public Integer getVersion() {
		return version;
	}
	public void setVersion(Integer version) {
		this.version = version;
	}
	
	@DynamoDBHashKey(attributeName="id")
	@DynamoDBAutoGeneratedKey
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	
	@DynamoDBAttribute(attributeName="ip_address")
	public String getIp_address() {
		return ip_address;
	}
	public void setIp_address(String ip_address) {
		this.ip_address = ip_address;
	}
	
	@DynamoDBAttribute(attributeName="location")
	public String getLocation() {
		return location;
	}
	
	public void setLocation(String location) {
		this.location = location;
	}
	
	@DynamoDBAttribute(attributeName="name")
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	
	@DynamoDBAttribute(attributeName="serialNumber")
	public String getSerialNumber() {
		return serialNumber;
	}
	public void setSerialNumber(String serialnumber) {
		this.serialNumber = serialnumber;
	}
	
	@DynamoDBAttribute(attributeName="uuid")
	public String getUuid() {
		return uuid;
	}
	public void setUuid(String uuid) {
		this.uuid = uuid;
	}
	@Override
	public String toString() {
		return "Source [id=" + id + ", ip_address=" + ip_address
				+ ", location=" + location + ", name=" + name
				+ ", serialNumber=" + serialNumber + ", uuid=" + uuid
				+ ", version=" + version + "]";
	}
	
	
}
